"""
Django settings for Iris project.

Generated by 'django-admin startproject' using Django 2.1.7.

For more information on this file, see
https://docs.djangoproject.com/en/2.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.1/ref/settings/
"""

import datetime
import os
from pathlib import Path

import requests
import sentry_sdk
from dotenv import load_dotenv
from sentry_sdk.integrations.django import DjangoIntegration

from . import get_env_variable

from typing import Dict, Any, List, Tuple, Union

env_path = Path(".") / ".env"
load_dotenv(dotenv_path=env_path)


# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR: str = os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY: str = get_env_variable('SECRET_KEY')
SITE_NAME: str = 'Iris'

# SECURITY WARNING: don't run with debug turned on in production!

Q_CLUSTER: Dict[str, Any] = {
    'name': 'Iris',
    'workers': 8,
    'recycle': 500,
    'timeout': 6000,
    'save_limit':0,
    'compress': True,
    'save_limit': 0,
    'queue_limit': 5000,
    'cpu_affinity': 4,
    'label': 'Django Q',
    'orm': 'default',
    'django_redis': 'default',
}

EMAIL_HOST: str = 'smtp.sendgrid.net'
EMAIL_HOST_USER: str  = get_env_variable('EMAIL_HOST_USER')
EMAIL_HOST_PASSWORD: str  = get_env_variable('EMAIL_HOST_PASSWORD')
EMAIL_PORT: int = 587
EMAIL_USE_TLS: bool = True
# Application definition


INSTALLED_APPS: List[str] = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.sessions',
    'django.contrib.contenttypes',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'django.contrib.humanize',
    'rest_framework.authtoken',
    'django_q',
    'simple_history',
    'corsheaders',
    'communications.apps.CommunicationsConfig',
    'tickets.apps.TicketsConfig',
    'users.apps.UsersConfig',
    'matrix.apps.MatrixConfig',
    'customers.apps.CustomersConfig',
    'slackapp.apps.SlackappConfig',
    'drives.apps.DrivesConfig',
    'pulso.apps.PulsoConfig',
    'escalation_ti.apps.EscalationTiConfig',
    'escalation_finance.apps.EscalationFinanceConfig',
    'formerCustomers.apps.FormercustomersConfig',
    'iclass.apps.IclassConfig',
    'voipnow.apps.VoipnowConfig',
    'qc.apps.QcConfig',
    'tech_support.apps.TechSupportConfig',
    'operators.apps.OperatorsConfig',
    'retentions.apps.RetentionsConfig',
    'webhooks.apps.WebhooksConfig',
    'liveagent.apps.LiveagentConfig',
    'dynamic_preferences',
    'drf_yasg',
    'phonenumber_field',
]

MIDDLEWARE: List[str] = [
    'django.middleware.gzip.GZipMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'simple_history.middleware.HistoryRequestMiddleware',
    'corsheaders.middleware.CorsMiddleware',
]

CORS_ORIGIN_ALLOW_ALL: bool = True

CORS_ORIGIN_WHITELIST: List[str] = []

CORS_ALLOW_METHODS: List[str] = [
    'DELETE',
    'GET',
    'OPTIONS',
    'PATCH',
    'POST',
    'PUT',
]
ALLOWED_HOSTS=['*']

CORS_ALLOW_HEADERS: List[str] = [
    'accept',
    'accept-encoding',
    'authorization',
    'content-type',
    'dnt',
    'origin',
    'user-agent',
    'x-csrftoken',
    'x-requested-with',
]

CORS_ORIGIN_ALLOW_ALL: bool = True

ROOT_URLCONF: str = 'config.urls'

TEMPLATES: List[Dict[str, Any]] = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'Interfaz/template')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'django.template.context_processors.request',
                'dynamic_preferences.processors.global_preferences',
            ],
        },
    },
]

WSGI_APPLICATION: str = 'config.wsgi.application'

SWAGGER_SETTINGS: Dict[str, Any] = {
    'SECURITY_DEFINITIONS': {
        'api_key': {
            'type': 'apiKey',
            'in': 'header',
            'name': 'Authorization'
        }
    },
    'USE_SESSION_AUTH': False
}

REST_FRAMEWORK: Dict[str, Union[Tuple[str], List[str]]] = {
    'DEFAULT_PERMISSION_CLASSES': (
        'users.permissions.Permission',
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
        'rest_framework.authentication.SessionAuthentication',
        'rest_framework.authentication.BasicAuthentication',
        'users.permissions.Authentication',
    ),
    'DEFAULT_FILTER_BACKENDS': [
        'url_filter.integrations.drf.DjangoFilterBackend',
    ],
}

# available settings with their default values
DYNAMIC_PREFERENCES: Dict[str, Any] = {

    # a python attribute that will be added to model instances with preferences
    # override this if the default collide with one of your models attributes/fields
    'MANAGER_ATTRIBUTE': 'preferences',

    # The python module in which registered preferences will be searched within each app
    'REGISTRY_MODULE': 'dynamic_preferences_registry',

    # Allow quick editing of preferences directly in admin list view
    # WARNING: enabling this feature can cause data corruption if multiple users
    # use the same list view at the same time, see https://code.djangoproject.com/ticket/11313
    'ADMIN_ENABLE_CHANGELIST_FORM': False,

    # Customize how you can access preferences from managers. The default is to
    # separate sections and keys with two underscores. This is probably not a settings you'll
    # want to change, but it's here just in case
    'SECTION_KEY_SEPARATOR': '__',

    # Use this to disable caching of preference. This can be useful to debug things
    'ENABLE_CACHE': True,

    # Use this to disable checking preferences names. This can be useful to debug things
    'VALIDATE_NAMES': True,
}


JWT_AUTH: Dict[str, Any] = {

    'JWT_ENCODE_HANDLER':
    'rest_framework_jwt.utils.jwt_encode_handler',

    'JWT_DECODE_HANDLER':
    'rest_framework_jwt.utils.jwt_decode_handler',

    'JWT_PAYLOAD_HANDLER':
    'rest_framework_jwt.utils.jwt_payload_handler',

    'JWT_PAYLOAD_GET_USER_ID_HANDLER':
    'rest_framework_jwt.utils.jwt_get_user_id_from_payload_handler',

    'JWT_RESPONSE_PAYLOAD_HANDLER':
    'rest_framework_jwt.utils.jwt_response_payload_handler',

    'JWT_SECRET_KEY': SECRET_KEY,
    'JWT_GET_USER_SECRET_KEY': None,
    'JWT_PUBLIC_KEY': None,
    'JWT_PRIVATE_KEY': None,
    'JWT_ALGORITHM': 'HS256',
    'JWT_VERIFY': True,
    'JWT_VERIFY_EXPIRATION': True,
    'JWT_LEEWAY': 0,
    'JWT_EXPIRATION_DELTA': datetime.timedelta(days=7),
    'JWT_AUDIENCE': None,
    'JWT_ISSUER': None,

    'JWT_ALLOW_REFRESH': True,
    'JWT_REFRESH_EXPIRATION_DELTA': datetime.timedelta(days=7),

    'JWT_AUTH_HEADER_PREFIX': 'JWT',
    'JWT_AUTH_COOKIE': None,

}


# Database
# https://docs.djangoproject.com/en/2.1/ref/settings/#databases


DATABASES: Dict[str, Dict[str, Any]] = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': get_env_variable('DATABASE_NAME'),
        'USER': get_env_variable('DATABASE_USER'),
        'PASSWORD': get_env_variable('DATABASE_PASSWORD'),
        'HOST': get_env_variable('DATABASE_HOST'),
        'PORT': get_env_variable('DATABASE_PORT'),
        'CONN_MAX_AGE':600,
    }
}


CACHES: Dict[str, Dict[str, Any]] = {
    "default": {
        "BACKEND": "django_redis.cache.RedisCache",
        "LOCATION": "redis://127.0.0.1:6379/2",
        "OPTIONS": {
            "CLIENT_CLASS": "django_redis.client.DefaultClient",
        }
    }
}

REST_FRAMEWORK_CACHE: Dict[str, Any] = {
    'DEFAULT_CACHE_BACKEND': 'default',
    'DEFAULT_CACHE_TIMEOUT': 86400,
}

CACHE_MIDDLEWARE: Dict[str, Any] ={
    'IGNORE':['matrix/*', 'user/*','tickets/massive*','communications/massive*']
}


# Password validation
# https://docs.djangoproject.com/en/2.1/ref/settings/#auth-password-validators


AUTH_PASSWORD_VALIDATORS: List[Dict[str, str]] = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.1/topics/i18n/

LANGUAGE_CODE: str = 'en-us'

TIME_ZONE: str = 'America/Lima'

USE_I18N: bool = True

USE_L10N: bool = True

USE_TZ: bool = True

STATIC_URL: str = '/static/'
STATIC_ROOT: str = os.path.join(BASE_DIR, 'static', 'static_root')
STATICFILES_DIRS: Tuple[str] = (
    os.path.join(BASE_DIR, 'static', 'static_dirs'),
)

MEDIA_URL: str = '/media/'
MEDIA_ROOT: str = os.path.join(BASE_DIR, 'media')

DATA_UPLOAD_MAX_MEMORY_SIZE: int = 10485760
FILE_UPLOAD_MAX_MEMORY_SIZE: int = 10485760
